"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
exports.deviceFetch = exports.operatorFetch = exports.baseFetch = exports.customerFetch = exports.statisticsFetch = exports.systemFetch = void 0;
var constants_1 = require("../config/constants");
var app = getApp();
var fetch = function (req) {
    return new Promise(function (resolve, reject) {
        var token = app.globalData.token;
        wx.request(__assign(__assign({}, req), { header: token
                ? __assign({ token: token }, req.header) : req.header, success: resolve, fail: reject }));
    }).then(function (res) {
        var _a = res.data, code = _a.code, otherkeys = __rest(_a, ["code"]);
        if (code === constants_1.successCode) {
            console.log(res);
            if (res.header['Set-Cookie'])
                return {
                    header: res.header,
                    data: otherkeys
                };
            return otherkeys;
        }
        else if (code === constants_1.logoutode) {
            app.resetUserinfo();
            wx.reLaunch({
                url: '/pages/index/index'
            });
            throw {
                errMsg: res.data.msg || '网络异常'
            };
        }
        else {
            throw {
                errMsg: res.data.msg || '网络异常'
            };
        }
    });
};
var systemFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.SYSTEM_SERVER_URL + req.url }));
};
exports.systemFetch = systemFetch;
var statisticsFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.STATISTICS_SERVER_URL + req.url }));
};
exports.statisticsFetch = statisticsFetch;
var customerFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.CUSTOMER_SERVER_URL + req.url }));
};
exports.customerFetch = customerFetch;
var baseFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.BASE_SERVER_URL + req.url }));
};
exports.baseFetch = baseFetch;
var operatorFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.OPERATOR_SERVER_URL + req.url }));
};
exports.operatorFetch = operatorFetch;
var deviceFetch = function (req) {
    return fetch(__assign(__assign({}, req), { url: constants_1.masterUrl.DEVICE_SERVEL_URL + req.url }));
};
exports.deviceFetch = deviceFetch;
exports["default"] = fetch;
